<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <template>
                <div v-if="workers.length === 0">
                    <AnimationComponent text="There are currently no workers. Create one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="0.8"/>
                </div>
                <ListPage v-else>
                    <q-list separator bordered>
                        <WorkerItem v-for="w in workers" :key="w.id" :worker="w"/>
                    </q-list>
                </ListPage>
                <q-btn fab color="accent" icon="add" class="fixed-bottom-right q-ma-lg" to="/worker/create">
                    <q-tooltip anchor="center left" self="center right">
                        Create a new worker
                    </q-tooltip>
                </q-btn>

            </template>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import WorkerItem from "components/Entities/List/WorkerItem.vue";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import ListPage from "components/Core/ListPage.vue";

@Component({
    components: {ListPage, WorkerItem, AnimationComponent, DocumentWrapper}
})
export default class Workers extends Vue {
    layoutTabs = [];

    workers: WorkerPrincipalResponse[] = [];


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<WorkerPrincipalResponse[]>(`Worker?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.workers = o;
            }
        })

    }

    async created() {
        await this.loadFloors();
    }
}
</script>
